#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;
#define rep(i, a, b) for(ll i = a; i < (b); ++i)
#define all(x) begin(x),end(x)
#define sz(x) (int)(x).size()

int main() {
    srand(time(0));
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    cout << setprecision(9) << fixed;

    auto f = [](ll w, ll h) {
        return (w * (w-1)) / 2 * (h * (h-1)) / 2;
    };

    auto r = [&](ll w, ll h, ll wi, ll hi) {
        ll wl = wi, wr = w - wi - 1, hl = hi, hr = h - hi - 1;
        return (w-1) * (h-1) + (w-1) * hl * hr + (h-1) * wl * wr;
    };

    vi values;
    rep(w, 2, 1013) rep(h, 2, 48) {
        ll size = f(w, h);
        values.push_back(size);
        rep(i, 0, 20) {
            values.push_back(size - r(w, h, rand() % w, rand() % h));
        }
    }

    sort(all(values));
    cout << *rbegin(values) << endl;
}
