#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;
#define rep(i, a, b) for(ll i = a; i < (b); ++i)
#define all(x) begin(x),end(x)
#define sz(x) (int)(x).size()

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    cout << setprecision(9) << fixed;
    using ld = long double;
    ll n;
    cin >> n;
    vvi a(n, vi(n));
    for (auto& x : a) for (auto& z : x)
        cin >> z;
    ll d = 2e3;
    ll initx = d, inity = d;
    vvi visited(2 * d + 1, vi(2 * d + 1, 1e18));
    visited[initx][inity] = 0;
    priority_queue<tuple<ll,ll,ll>,vector<tuple<ll,ll,ll>>,greater<>> pq;
    pq.emplace(0, initx, inity);
    ld ans = 0;
    ld cons = 1;
    cout << setprecision(20) << fixed;
    while (!empty(pq)) {
        auto [dd, x, y] = pq.top(); pq.pop();
        if (dd != visited[x][y]) continue;
        ans += 1;
        if (!x || !y || x + 1 == size(visited) || y + 1 == ssize(visited))
            return cout << (ans * ld(1e40 / dd / dd) / cons), 0;
        auto truemod = [&] (ll x) { return ((x % n) + n) % n;};
        auto f = [&] (int u, int v) {

            ll w = 1 + abs(a[truemod(x)][truemod(y)] - a[truemod(x + u)][truemod(y + v)]);
            if (w + dd < visited[x + u][y + v]) {
                visited[x + u][y + v] = w + dd;
                pq.emplace(w + dd, x + u, y + v);
            }
        };
        f(-1, 0);
        f(0, -1);
        f(1, 0);
        f(0, 1);
    }
}
